/*******************************<+>***************************
 **                             DTA
 *************************************************************
 **
 **  $Id: Dictionary.h,v 1.4 1994/02/18 20:35:53 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Dictionary.h,v $
 **
 **  What @(#):
 **
 **  Author: Dale T. Anderson
 **
 *******************************<+>***************************/
 
#ifndef _Dictionary_h
#define _Dictionary_h

typedef int (*XnTextFilterProc) ();

#define XN_SHORT_INT   1
#define XN_SHORT_POS_INT   2
#define XN_SHORT_NEG_INT   3

#define XN_LONG_INT   4
#define XN_LONG_POS_INT   5
#define XN_LONG_NEG_INT   6

typedef enum {
    XN_SHORT = 0,
    XN_INT = 1,
    XN_FLOAT = 2,
    XN_DOUBLE = 3,
    XN_STR = 4,
    XN_CHAR,
    XN_BEARING,
    XN_LATLON,
    XN_LATLONALT,
    XN_DTG
} XnDataType;

/*
 * Attribute data structures for each data item
 */

typedef struct {
    int             min;
    int             max;
    int             def;
    int             digits;
}               XnIntAttr;

typedef struct {
    float           min;
    float           max;
    float           def;
    int             digits;
    int             accuracy;
}               XnRealAttr;

typedef struct {
    int             columns;
}               XnTextAttr;

typedef union {
    XnIntAttr      intattr;
    XnRealAttr     realattr;
    XnTextAttr     textattr;
}               XnDataAttr;

typedef struct {
    char           *title;
    int             key;
    XnDataType     type;
    XnDataAttr     item;
}               XnItemAttr;

#endif
