/*******************************<+>***************************
 **                             PRC
 *************************************************************
 **
 **  $Id: Icon.c,v 1.3 1993/09/14 01:17:11 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Icon.c,v $
 **
 **  Module Name:
 **
 **  Classification:  Unclassified
 **
 **  Author:          Dale T. Anderson
 **
 *******************************<+>***************************/

#include <Xm/Xm.h>

int XnIsWidgetMapped (w)
Widget w;
{
    XWindowAttributes window_attributes;

    XGetWindowAttributes (XtDisplay (w), XtWindow (w),
	&window_attributes);
    return (window_attributes.map_state != IsUnmapped);
}

void XnRaiseIcon (w)
Widget w;
{
    Window window;
    Window root;
    Window parent;
    Window *children;
    int nchildren;

    XtVaGetValues (w, XmNiconWindow, &window, NULL);

    if (window) {

	while (XQueryTree (XtDisplay (w),
		window, &root, &parent, &children, &nchildren) && parent != root) {
	    if (nchildren)
		XFree ((char *) children);
	    window = parent;
	}

	XRaiseWindow (XtDisplay (w), window);
    }
}

void XnSetIconPixmap (shell, image)
Widget shell;
Pixmap image;
{
    Window window, root;
    unsigned x, y, width, height, border_width, depth;
    Display *dpy = XtDisplay (shell);

    XtVaGetValues (shell, XmNiconWindow, &window, NULL);

    if (!window) {
	if (!XGetGeometry (dpy, image, &root, &x, &y,
		&width, &height, &border_width, &depth) ||
		!(window = XCreateSimpleWindow (dpy, root, 0, 0, width * 5, height * 5,
		(unsigned) 0, CopyFromParent, CopyFromParent))) {
	    XtVaSetValues (shell, XmNiconPixmap, image, NULL);
	    return;
	}
	XtVaSetValues (shell, XmNiconWindow, window, NULL);
    }
    XSetWindowBackgroundPixmap (dpy, window, image);
    XnRaiseIcon (shell);
}
