/*******************************<+>***************************
 **                             PRC
 *************************************************************
 **
 **  $Id: Pixmap.c,v 1.3 1994/02/18 19:56:19 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Pixmap.c,v $
 **
 **  Module Name:
 **
 **  Classification:  Unclassified
 **
 **  Author:          Dale T. Anderson
 **
 *******************************<+>***************************/

#include <Xm/Xm.h>

#include <Xn/Xn.h>

void            XnClearPixmap (display, pixmap, gc, width, height)
Display        *display;
Pixmap          pixmap;
GC              gc;
int             width;
int             height;
{
    XSetForeground (display, gc, BlackPixel (display, DefaultScreen (display)));
    XFillRectangle (display, pixmap, gc, 0, 0, width, height);
    XSetForeground (display, gc, WhitePixel (display, DefaultScreen (display)));
}

static void     resize (w, data, reason)
Widget          w;
XnPixmapData   *data;
int            *reason;
{
    XtVaGetValues (w,
		   XmNwidth, &data->width,
		   XmNheight, &data->height,
		   NULL);

    if (data->pixmap)
	XFreePixmap (XtDisplay (w), data->pixmap);


    printf ("%x %d %d\n", w, data->height, data->width);
    data->pixmap = XCreatePixmap (XtDisplay (w), XtWindow (w),
				  data->width, data->height, 8);

    XSetWindowBackgroundPixmap (XtDisplay (w), XtWindow (w), data->pixmap);
}

void            XnInitDrawingArea (draw, pixmap, expose)
Widget          draw;
XnPixmapData   *pixmap;
XtCallbackProc  expose;
{
    pixmap->pixmap = 0;
    resize (draw, pixmap, NULL);

    XnAddCallback (draw, XmNresizeCallback, resize, pixmap);
    XnAddCallback (draw, XmNexposeCallback, expose, pixmap);
}
