/*******************************<+>***************************
 **                             PRC
 *************************************************************
 **
 **  $Id: Print.c,v 1.4 1994/02/18 19:56:20 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Print.c,v $
 **
 **  Module Name:
 **
 **  Classification:  Unclassified
 **
 **  Author:          Dale T. Anderson
 **
 *******************************<+>***************************/

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/MessageB.h>

#include "Xn.h"

static char *message = "\n\
To print a window do the following:\n\
\n\
1) Uncover and resize the window to be printed.\n\
2) Select 'OK' from this window.\n\
3) Click the mouse inside the window to be printed.\n\
\n\
Print Command: %s";

static char *command = "xwd -frame | xpr -dev ps | lpr &";

static void     cancel_cb (w, client, call)
Widget          w;
XtPointer client;
XtPointer call;
{
    XnPopdown (w);
}

static void     ok_cb (w, client, call)
Widget          w;
XtPointer client;
XtPointer call;
{
    system (command);
    cancel_cb (w, client, call);
}

void            XnPrintWindow (parent)
Widget          parent;
{
    static Widget dialog = NULL;

    if (!dialog) {
	dialog = XmCreateInformationDialog (parent, "dialog", NULL, 0);
	XnWidgetPutStr (XtParent (dialog), "Print Window");
	XnSetNoResize (XtParent (dialog));

	XnWidgetPrintf (dialog, message, command);

	XtUnmanageChild (XmMessageBoxGetChild (dialog, XmDIALOG_HELP_BUTTON));

	XnAddCallback (dialog, XmNokCallback, ok_cb, 0);
	XnAddCallback (dialog, XmNcancelCallback, cancel_cb, 0);
    }

    XtManageChild (dialog);
    XtPopup (XtParent (dialog), XtGrabNone);
}
