/*******************************<+>***************************
 **                             PRC
 *************************************************************
 **
 **  $Id: Toolbar.c,v 1.5 1994/02/18 19:56:24 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Toolbar.c,v $
 **
 **  Module Name:
 **
 **  Classification:  Unclassified
 **
 **  Author:          Dale T. Anderson
 **
 *******************************<+>***************************/

#include <stdio.h>

#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/BulletinB.h>
#include <Xm/Frame.h>

#include <Xn/Xn.h>

Widget XnCreateToolbar (parent, data, ratio)
Widget parent;
XnCallbackData *data;
double ratio;
{
    Widget toolbar;
    Pixmap icon;
    Widget frame;
    Pixel bg;
    int width;
    int height;
    int x;
    int i;

    frame = XtVaCreateManagedWidget ("toolbar",
	xmFrameWidgetClass, parent,
	NULL);

    toolbar = XtVaCreateWidget ("toolbar",
	xmBulletinBoardWidgetClass, frame,
	XmNmarginHeight, 2,
	XmNmarginWidth, 2,
	XmNunitType, XmPIXELS,
	NULL);

    x = 2;

    XtVaGetValues (parent,
	XmNbackground, &bg,
	NULL);

    for (i = 0; data [i].name; i++) {
	if (data[i].name && *data[i].name) {
	    icon = XnIconRead (parent, data[i].name,
		&width, &height, 0, ratio);
	    if (icon) {
		data [i].w = XtVaCreateManagedWidget (data[i].name,
			xmPushButtonWidgetClass, toolbar,
			XmNlabelPixmap, icon,
			XmNlabelType, XmPIXMAP,
			XmNheight, height + 10,
			XmNwidth, width + 10,
			XmNx, x,
			NULL);
		x += (width + (int)((double)(height) / 2.0));
		if (!data[i].data)
		    data[i].data = data[i].name;
		if (data[i].proc)
		    XnAddCallback (data[i].w, XmNactivateCallback,
			data[i].proc, data[i].data);
	    } else {
		fprintf (stderr, "Error opening icon %s\n", data[i].name);
	    }
	} else {
	    x += (int)((double)(height) / 2.0);
	}
    }

    if (XmIsForm (parent)) {
	XtVaSetValues (toolbar,
	    XmNleftAttachment, XmATTACH_FORM,
	    XmNrightAttachment, XmATTACH_FORM,
	    XmNbottomAttachment, XmATTACH_FORM,
	    NULL);
    }

    XtManageChild (toolbar);

    return (frame);
}
