/*******************************<+>***************************
 **                     DTA
 *************************************************************
 **
 **  $Id: Opcode.C,v 1.4 1994/02/18 22:25:53 dta Exp $
 **
 **  $Source: /cvs/progs/pexdb/Opcode.C,v $
 **
 **  What @ (#):
 **
 **  Author: Dale T. Anderson
 **
 *******************************<+>***************************/
 
#include <stdio.h>
#include <stdio.h>
#include <string.h>

#include <Xn/Xn.h>

#include "Pexdb.h"

static void PrintAddToNameSet (Widget w, PEXOCData *data)
{
    Print (w, data->data.AddToNameSet.count, "count");
    char buffer [256];
    for (int i = 0; i < data->data.AddToNameSet.count; i++) {
	sprintf (buffer, "%3d", i);
	Print (w, data->data.AddToNameSet.names [i], buffer);
    }
}

static void PrintApplicationData (Widget w, PEXOCData *data)
{
    Print (w, data->data.ApplicationData.length, "length");
    Print (w, data->data.ApplicationData.data, "data");
}

static void PrintCellArray (Widget w, PEXOCData *data)
{
    Print (w, data->data.CellArray.point1, "point1");
    Print (w, data->data.CellArray.point2, "point2");
    Print (w, data->data.CellArray.point3, "point3");
    Print (w, data->data.CellArray.col_count, "col_count");
    Print (w, data->data.CellArray.row_count, "row_count");
    char buffer [256];
    for (int i = 0; i < data->data.CellArray.col_count * data->data.CellArray.row_count; i++) {
	sprintf (buffer, "%3d", i);
	Print (w, data->data.CellArray.color_indices [i], buffer);
    }
}

static void PrintCellArray2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.CellArray2D.point1, "point1");
    Print (w, data->data.CellArray2D.point2, "point2");
    Print (w, data->data.CellArray2D.col_count, "col_count");
    Print (w, data->data.CellArray2D.row_count, "row_count");
    char buffer [256];
    for (int i = 0; i < data->data.CellArray2D.col_count * data->data.CellArray.row_count; i++) {
	sprintf (buffer, "%3d", i);
	Print (w, data->data.CellArray2D.color_indices [i], buffer);
    }
}

static void PrintEncodedAnnoText (Widget w, PEXOCData *data)
{
    Print (w, data->data.EncodedAnnoText.origin, "origin");
    Print (w, data->data.EncodedAnnoText.offset, "offset");
    Print (w, data->data.EncodedAnnoText.count, "count");
    Print (w, data->data.EncodedAnnoText.encoded_text, "encoded_text");
}

static void PrintEncodedAnnoText2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.EncodedAnnoText2D.origin, "origin");
    Print (w, data->data.EncodedAnnoText2D.offset, "offset");
    Print (w, data->data.EncodedAnnoText2D.count, "count");
    Print (w, data->data.EncodedAnnoText2D.encoded_text, "encoded_text");
}

static void PrintEncodedText (Widget w, PEXOCData *data)
{
    Print (w, data->data.EncodedText.origin, "origin");
    Print (w, data->data.EncodedText.vector1, "vector1");
    Print (w, data->data.EncodedText.vector2, "vector2");
    Print (w, data->data.EncodedText.count, "count");
    Print (w, data->data.EncodedText.encoded_text, "encoded_text");
}

static void PrintEncodedText2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.EncodedText2D.origin, "origin");
    Print (w, data->data.EncodedText2D.count, "count");
    Print (w, data->data.EncodedText2D.encoded_text, "encoded_text");
}

static void PrintExecuteStructure (Widget w, PEXOCData *data)
{
    Print (w, data->data.ExecuteStructure.structure, "structure");
}

static void PrintExtendedCellArray (Widget w, PEXOCData *data)
{
    Print (w, data->data.ExtendedCellArray.point1, "point1");
    Print (w, data->data.ExtendedCellArray.point2, "point2");
    Print (w, data->data.ExtendedCellArray.point3, "point3");
    Print (w, data->data.ExtendedCellArray.col_count, "col_count");
    Print (w, data->data.ExtendedCellArray.row_count, "row_count");
    Print (w, data->data.ExtendedCellArray.color_type, "color_type");
    Print (w, data->data.ExtendedCellArray.color_type,
	data->data.ExtendedCellArray.colors,
	data->data.ExtendedCellArray.col_count
	* data->data.ExtendedCellArray.row_count,
	"colors");
}

static void PrintFillArea (Widget w, PEXOCData *data)
{
    Print (w, data->data.FillArea.shape_hint, "shape_hint");
    Print (w, data->data.FillArea.ignore_edges, "ignore_edges");
    Print (w, data->data.FillArea.count, "count");
    Print (w, *data->data.FillArea.points, "points");
}

static void PrintFillArea2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.FillArea2D.shape_hint, "shape_hint");
    Print (w, data->data.FillArea2D.ignore_edges, "ignore_edges");
    Print (w, data->data.FillArea2D.count, "count");
    Print (w, *data->data.FillArea2D.points, "points");
}

static void PrintFillAreaSet (Widget w, PEXOCData *data)
{
    Print (w, data->data.FillAreaSet.shape_hint, "shape_hint");
    Print (w, data->data.FillAreaSet.ignore_edges, "ignore_edges");
    Print (w, data->data.FillAreaSet.contour_hint, "contour_hint");
    Print (w, data->data.FillAreaSet.count, "count");
    char buffer [256];
    for (int i = 0; i < data->data.FillAreaSet.count; i++) {
	sprintf (buffer, "%3d", i);
	Print (w, data->data.FillAreaSet.point_lists [i], buffer);
    }
}

static void PrintFillAreaSet2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.FillAreaSet2D.shape_hint, "shape_hint");
    Print (w, data->data.FillAreaSet2D.ignore_edges, "ignore_edges");
    Print (w, data->data.FillAreaSet2D.contour_hint, "contour_hint");
    Print (w, data->data.FillAreaSet2D.count, "count");
    char buffer [256];
    for (int i = 0; i < data->data.FillAreaSet2D.count; i++) {
	sprintf (buffer, "%3d", i);
	Print (w, data->data.FillAreaSet2D.point_lists [i], buffer);
    }
}

static void PrintFillAreaSetWithData (Widget w, PEXOCData *data)
{
    Print (w, data->data.FillAreaSetWithData.shape_hint, "shape_hint");
    Print (w, data->data.FillAreaSetWithData.ignore_edges, "ignore_edges");
    Print (w, data->data.FillAreaSetWithData.contour_hint, "contour_hint");
    Print (w, data->data.FillAreaSetWithData.facet_attributes, "facet_attributes");
    Print (w, data->data.FillAreaSetWithData.vertex_attributes, "vertex_attributes");
    Print (w, data->data.FillAreaSetWithData.color_type, "color_type");
    Print (w, data->data.FillAreaSetWithData.count, "count");
    Print (w,
	data->data.FillAreaSetWithData.facet_attributes,
	data->data.FillAreaSetWithData.facet_data,
	"facet_data");
    char buffer [256];
    for (int i = 0; i < data->data.FillAreaSetWithData.count; i++) {
	sprintf (buffer, "%3d", i);
	Print (w,
	    data->data.FillAreaSetWithData.vertex_attributes,
	    data->data.FillAreaSetWithData.vertex_lists [i], buffer);
    }
}

static void PrintFillAreaWithData (Widget w, PEXOCData *data)
{
    Print (w, data->data.FillAreaWithData.shape_hint, "shape_hint");
    Print (w, data->data.FillAreaWithData.ignore_edges, "ignore_edges");
    Print (w, data->data.FillAreaWithData.facet_attributes, "facet_attributes");
    Print (w, data->data.FillAreaWithData.vertex_attributes, "vertex_attributes");
    Print (w, data->data.FillAreaWithData.color_type, "color_type");
    Print (w,
	data->data.FillAreaWithData.facet_attributes,
	data->data.FillAreaWithData.facet_data,
	"facet_data");
    Print (w, data->data.FillAreaWithData.count, "count");
    Print (w,
	data->data.FillAreaWithData.vertex_attributes,
	data->data.FillAreaWithData.vertices,
	data->data.FillAreaWithData.count,
	"vertices");
}

static void PrintGDP (Widget w, PEXOCData *data)
{
    Print (w, data->data.GDP.gdp_id, "gdp_id");
    Print (w, data->data.GDP.count, "count");
    Print (w, *data->data.GDP.points, "points");
    Print (w, data->data.GDP.length, "length");
    Print (w, data->data.GDP.data, "data");
}

static void PrintGDP2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.GDP2D.gdp_id, "gdp_id");
    Print (w, data->data.GDP2D.count, "count");
    Print (w, *data->data.GDP2D.points, "points");
    Print (w, data->data.GDP2D.length, "length");
    Print (w, data->data.GDP2D.data, "data");
}

static void PrintGSE (Widget w, PEXOCData *data)
{
    Print (w, data->data.GSE.id, "id");
    Print (w, data->data.GSE.length, "length");
    Print (w, data->data.GSE.data, "data");
}

static void PrintLabel (Widget w, PEXOCData *data)
{
    Print (w, data->data.Label.label, "label");
}

static void PrintMarkers (Widget w, PEXOCData *data)
{
    Print (w, data->data.Markers.count, "count");
    Print (w, *data->data.Markers.points, "points");
}

static void PrintMarkers2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.Markers2D.count, "count");
    Print (w, *data->data.Markers2D.points, "points");
}

static void PrintNURBCurve (Widget w, PEXOCData *data)
{
    Print (w, data->data.NURBCurve.rationality, "rationality");
    Print (w, data->data.NURBCurve.order, "order");
    Print (w, *data->data.NURBCurve.knots, "knots");
    Print (w, data->data.NURBCurve.count, "count");
    Print (w,
	0,
	data->data.NURBCurve.points,
	data->data.NURBCurve.count,
	"points");
    Print (w, data->data.NURBCurve.tmin, "tmin");
    Print (w, data->data.NURBCurve.tmax, "tmax");
}

static void PrintNURBSurface (Widget w, PEXOCData *data)
{
    Print (w, data->data.NURBSurface.rationality, "rationality");
    Print (w, data->data.NURBSurface.uorder, "uorder");
    Print (w, data->data.NURBSurface.vorder, "vorder");
    Print (w, *data->data.NURBSurface.uknots, "uknots");
    Print (w, *data->data.NURBSurface.vknots, "vknots");
    Print (w, data->data.NURBSurface.col_count, "col_count");
    Print (w, data->data.NURBSurface.row_count, "row_count");
    Print (w,
	0,
	data->data.NURBSurface.points,
	data->data.NURBSurface.col_count * data->data.NURBSurface.row_count,
	"points");
    Print (w, data->data.NURBSurface.curve_count, "curve_count");
    char buffer [256];
    for (int i = 0; i < data->data.NURBSurface.curve_count; i++) {
	sprintf (buffer, "%3d", i);
	Print (w, data->data.NURBSurface.trim_curves [i], buffer);
    }
}

static void PrintPolyline (Widget w, PEXOCData *data)
{
    Print (w, data->data.Polyline.count, "count");
    char buffer [256];
    for (int i = 0; i < data->data.Polyline.count; i++) {
	sprintf (buffer, "%3d", i);
	Print (w, data->data.Polyline.points [i], buffer);
    }
}

static void PrintPolyline2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.Polyline2D.count, "count");
    char buffer [256];
    for (int i = 0; i < data->data.Polyline2D.count; i++) {
	sprintf (buffer, "%3d", i);
	Print (w, data->data.Polyline2D.points [i], buffer);
    }
}

static void PrintPolylineSetWithData (Widget w, PEXOCData *data)
{
    Print (w, data->data.PolylineSetWithData.vertex_attributes, "vertex_attributes");
    Print (w, data->data.PolylineSetWithData.color_type, "color_type");
    Print (w, data->data.PolylineSetWithData.count, "count");
    char buffer [256];
    for (int i = 0; i < data->data.PolylineSetWithData.count; i++) {
	sprintf (buffer, "%3d", i);
	Print (w,
	    data->data.PolylineSetWithData.vertex_attributes,
	    data->data.PolylineSetWithData.vertex_lists [i], buffer);
    }
}

static void PrintQuadrilateralMesh (Widget w, PEXOCData *data)
{
    Print (w, data->data.QuadrilateralMesh.shape_hint, "shape_hint");
    Print (w, data->data.QuadrilateralMesh.facet_attributes, "facet_attributes");
    Print (w, data->data.QuadrilateralMesh.vertex_attributes, "vertex_attributes");
    Print (w, data->data.QuadrilateralMesh.color_type, "color_type");
    Print (w,
	data->data.QuadrilateralMesh.facet_attributes,
	data->data.QuadrilateralMesh.facet_data,
	data->data.QuadrilateralMesh.row_count * data->data.QuadrilateralMesh.col_count,
	"facet_data");
    Print (w, data->data.QuadrilateralMesh.col_count, "col_count");
    Print (w, data->data.QuadrilateralMesh.row_count, "row_count");
    Print (w,
	data->data.QuadrilateralMesh.vertex_attributes,
	data->data.QuadrilateralMesh.vertices,
	data->data.QuadrilateralMesh.row_count * data->data.QuadrilateralMesh.col_count,
	"vertices");
}

static void PrintRemoveFromNameSet (Widget w, PEXOCData *data)
{
    Print (w, data->data.RemoveFromNameSet.count, "count");
    Print (w, *data->data.RemoveFromNameSet.names, "names");
}

static void PrintATextAlignment (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetATextAlignment.halignment, "halignment");
    Print (w, data->data.SetATextAlignment.valignment, "valignment");
}

static void PrintATextHeight (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetATextHeight.height, "height");
}

static void PrintATextPath (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetATextPath.path, "path");
}

static void PrintATextStyle (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetATextStyle.style, "style");
}

static void PrintATextUpVector (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetATextUpVector.vector, "vector");
}

static void PrintBFInteriorStyle (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetBFInteriorStyle.style, "style");
}

static void PrintBFInteriorStyleIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetBFInteriorStyleIndex.index, "index");
}

static void PrintBFReflectionAttributes (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetBFReflectionAttributes.attributes, "attributes");
}

static void PrintBFReflectionModel (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetBFReflectionModel.model, "model");
}

static void PrintBFSurfaceColor (Widget w, PEXOCData *data)
{
    Print (w, "BFSurfaceColor", 
	data->data.SetBFSurfaceColor.color_type,
	data->data.SetBFSurfaceColor.color);
}

static void PrintBFSurfaceColorIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetBFSurfaceColorIndex.index, "index");
}

static void PrintBFSurfaceInterpMethod (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetBFSurfaceInterpMethod.method, "method");
}

static void PrintCharExpansion (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetCharExpansion.expansion, "expansion");
}

static void PrintCharHeight (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetCharHeight.height, "height");
}

static void PrintCharSpacing (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetCharSpacing.spacing, "spacing");
}

static void PrintCharUpVector (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetCharUpVector.vector, "vector");
}

static void PrintColorApproxIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetColorApproxIndex.index, "index");
}

static void PrintCurveApprox (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetCurveApprox.method, "method");
    Print (w, data->data.SetCurveApprox.tolerance, "tolerance");
}

static void PrintDepthCueIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetDepthCueIndex.index, "index");
}

static void PrintEdgeBundleIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetEdgeBundleIndex.index, "index");
}

static void PrintFacetCullingMode (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetFacetCullingMode.mode, "mode");
}

static void PrintFacetDistinguishFlag (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetFacetDistinguishFlag.flag, "flag");
}

static void PrintGlobalTransform (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetGlobalTransform.transform, "transform");
}

static void PrintGlobalTransform2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetGlobalTransform2D.transform, "transform");
}

static void PrintHLHSRID (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetHLHSRID.hlhsr_id, "hlhsr_id");
}

static void PrintIndividualASF (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetIndividualASF.attribute, "attribute");
    Print (w, data->data.SetIndividualASF.asf, "asf");
}

static void PrintInteriorBundleIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetInteriorBundleIndex.index, "index");
}

static void PrintInteriorStyle (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetInteriorStyle.style, "style");
}

static void PrintInteriorStyleIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetInteriorStyleIndex.index, "index");
}

static void PrintLightSourceState (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetLightSourceState.enable_count, "enable_count");
    //Print (w, data->data.SetLightSourceState.enable, "enable");
    Print (w, data->data.SetLightSourceState.disable_count, "disable_count");
    //Print (w, data->data.SetLightSourceState.disable, "disable");
}

static void PrintLineBundleIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetLineBundleIndex.index, "index");
}

static void PrintLineColor (Widget w, PEXOCData *data)
{
    Print (w, "color", 
	data->data.SetLineColor.color_type,
	data->data.SetLineColor.color);
}

static void PrintLineColorIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetLineColorIndex.index, "index");
}

static void PrintLineType (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetLineType.line_type, "line_type");
}

static void PrintLineWidth (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetLineWidth.width, "width");
}

static void PrintLocalTransform (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetLocalTransform.composition, "composition");
    Print (w, data->data.SetLocalTransform.transform, "transform");
}

static void PrintLocalTransform2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetLocalTransform2D.composition, "composition");
    Print (w, data->data.SetLocalTransform2D.transform, "transform");
}

static void PrintMarkerBundleIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetMarkerBundleIndex.index, "index");
}

static void PrintMarkerColor (Widget w, PEXOCData *data)
{
    Print (w, "color", 
	data->data.SetMarkerColor.color_type,
	data->data.SetMarkerColor.color);
}

static void PrintMarkerColorIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetMarkerColorIndex.index, "index");
}

static void PrintMarkerScale (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetMarkerScale.scale, "scale");
}

static void PrintMarkerType (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetMarkerType.marker_type, "marker_type");
}

static void PrintModelClipFlag (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetModelClipFlag.flag, "flag");
}

static void PrintModelClipVolume (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetModelClipVolume.op, "op");
    Print (w, data->data.SetModelClipVolume.count, "count");
    Print (w, *data->data.SetModelClipVolume.half_spaces, "half_spaces");
}

static void PrintModelClipVolume2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetModelClipVolume2D.op, "op");
    Print (w, data->data.SetModelClipVolume2D.count, "count");
    Print (w, *data->data.SetModelClipVolume2D.half_spaces, "half_spaces");
}

static void PrintSetOfFillAreaSets (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetOfFillAreaSets.shape_hint, "shape_hint");
    Print (w, data->data.SetOfFillAreaSets.facet_attributes, "facet_attributes");
    Print (w, data->data.SetOfFillAreaSets.vertex_attributes, "vertex_attributes");
    Print (w, data->data.SetOfFillAreaSets.edge_attributes, "edge_attributes");
    Print (w, data->data.SetOfFillAreaSets.contour_hint, "contour_hint");
    Print (w, data->data.SetOfFillAreaSets.contours_all_one, "contours_all_one");
    Print (w, data->data.SetOfFillAreaSets.color_type, "color_type");
    Print (w, data->data.SetOfFillAreaSets.set_count, "set_count");
    Print (w,
	data->data.SetOfFillAreaSets.facet_attributes,
	data->data.SetOfFillAreaSets.facet_data,
	data->data.SetOfFillAreaSets.set_count,
	"facet_data");
    Print (w, data->data.SetOfFillAreaSets.vertex_count, "vertex_count");
    Print (w,
	data->data.SetOfFillAreaSets.vertex_attributes,
	data->data.SetOfFillAreaSets.vertices,
	data->data.SetOfFillAreaSets.vertex_count,
	"vertices");
    Print (w, data->data.SetOfFillAreaSets.index_count, "index_count");
    Print (w, *data->data.SetOfFillAreaSets.edge_flags, "edge_flags");
    Print (w, *data->data.SetOfFillAreaSets.connectivity, "connectivity");
}

static void PrintParaSurfCharacteristics (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetParaSurfCharacteristics.psc_type, "psc_type");
    Print (w, data->data.SetParaSurfCharacteristics.characteristics, "characteristics");
}

static void PrintPatternAttributes (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetPatternAttributes.ref_point, "ref_point");
    Print (w, data->data.SetPatternAttributes.vector1, "vector1");
    Print (w, data->data.SetPatternAttributes.vector2, "vector2");
}

static void PrintPatternAttributes2D (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetPatternAttributes2D.ref_point, "ref_point");
}

static void PrintPatternSize (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetPatternSize.width, "width");
    Print (w, data->data.SetPatternSize.height, "height");
}

static void PrintPickID (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetPickID.pick_id, "pick_id");
}

static void PrintPolylineInterpMethod (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetPolylineInterpMethod.method, "method");
}

static void PrintReflectionAttributes (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetReflectionAttributes.attributes, "attributes");
}

static void PrintReflectionModel (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetReflectionModel.model, "model");
}

static void PrintRenderingColorModel (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetRenderingColorModel.model, "model");
}

static void PrintSurfaceApprox (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetSurfaceApprox.method, "method");
    Print (w, data->data.SetSurfaceApprox.utolerance, "utolerance");
    Print (w, data->data.SetSurfaceApprox.vtolerance, "vtolerance");
}

static void PrintSurfaceColor (Widget w, PEXOCData *data)
{
    Print (w, "color", 
	data->data.SetSurfaceColor.color_type,
	data->data.SetSurfaceColor.color);
}

static void PrintSurfaceColorIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetSurfaceColorIndex.index, "index");
}

static void PrintSurfaceEdgeColor (Widget w, PEXOCData *data)
{
    Print (w, "color", 
	data->data.SetSurfaceEdgeColor.color_type,
	data->data.SetSurfaceEdgeColor.color);
}

static void PrintSurfaceEdgeColorIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetSurfaceEdgeColorIndex.index, "index");
}

static void PrintSurfaceEdgeFlag (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetSurfaceEdgeFlag.flag, "flag");
}

static void PrintSurfaceEdgeType (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetSurfaceEdgeType.edge_type, "edge_type");
}

static void PrintSurfaceEdgeWidth (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetSurfaceEdgeWidth.width, "width");
}

static void PrintSurfaceInterpMethod (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetSurfaceInterpMethod.method, "method");
}

static void PrintTextAlignment (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetTextAlignment.halignment, "halignment");
    Print (w, data->data.SetTextAlignment.valignment, "valignment");
}

static void PrintTextBundleIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetTextBundleIndex.index, "index");
}

static void PrintTextColor (Widget w, PEXOCData *data)
{
    Print (w, "color", 
	data->data.SetTextColor.color_type,
	data->data.SetTextColor.color);
}

static void PrintTextColorIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetTextColorIndex.index, "index");
}

static void PrintTextFontIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetTextFontIndex.index, "index");
}

static void PrintTextPath (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetTextPath.path, "path");
}

static void PrintTextPrecision (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetTextPrecision.precision, "precision");
}

static void PrintViewIndex (Widget w, PEXOCData *data)
{
    Print (w, data->data.SetViewIndex.index, "index");
}

static void PrintTriangleStrip (Widget w, PEXOCData *data)
{
    Print (w, data->data.TriangleStrip.facet_attributes, "facet_attributes");
    Print (w, data->data.TriangleStrip.vertex_attributes, "vertex_attributes");
    Print (w, data->data.TriangleStrip.color_type, "color_type");
    Print (w,
	data->data.TriangleStrip.facet_attributes,
	data->data.TriangleStrip.facet_data,
	data->data.TriangleStrip.count,
	"facet_data");
    Print (w, data->data.TriangleStrip.count, "count");
    Print (w,
	data->data.TriangleStrip.vertex_attributes,
	data->data.TriangleStrip.vertices,
	data->data.TriangleStrip.count,
	"vertices");
}

/*
 * PEX Opcodes
 */

static OpcodeData opcodes[] = {
    { PEXOCMarkerType, "MarkerType", (printer)(PrintMarkerType) },
    { PEXOCMarkerScale, "MarkerScale", (printer)(PrintMarkerType) },
    { PEXOCMarkerColorIndex, "MarkerColorIndex", (printer)(PrintMarkerColorIndex) },
    { PEXOCMarkerColor, "MarkerColor", (printer)(PrintMarkerColor) },
    { PEXOCMarkerBundleIndex, "MarkerBundleIndex", (printer)(PrintMarkerBundleIndex) },
    { PEXOCTextFontIndex, "TextFontIndex", (printer)(PrintTextFontIndex) },
    { PEXOCTextPrecision, "TextPrecision", (printer)(PrintTextPrecision) },
    { PEXOCCharExpansion, "CharExpansion", (printer)(PrintCharExpansion) },
    { PEXOCCharSpacing, "CharSpacing", (printer)(PrintCharSpacing) },
    { PEXOCTextColorIndex, "TextColorIndex", (printer)(PrintTextColorIndex) },
    { PEXOCTextColor, "TextColor", (printer)(PrintTextColor) },
    { PEXOCCharHeight, "CharHeight", (printer)(PrintCharHeight) },
    { PEXOCCharUpVector, "CharUpVector", (printer)(PrintCharUpVector) },
    { PEXOCTextPath, "TextPath", (printer)(PrintTextPath) },
    { PEXOCTextAlignment, "TextAlignment", (printer)(PrintTextAlignment) },
    { PEXOCATextHeight, "ATextHeight", (printer)(PrintATextHeight) },
    { PEXOCATextUpVector, "ATextUpVector", (printer)(PrintATextUpVector) },
    { PEXOCATextPath, "ATextPath", (printer)(PrintATextPath) },
    { PEXOCATextAlignment, "ATextAlignment", (printer)(PrintATextAlignment) },
    { PEXOCATextStyle, "ATextStyle", (printer)(PrintATextStyle) },
    { PEXOCTextBundleIndex, "TextBundleIndex", (printer)(PrintTextBundleIndex) },
    { PEXOCLineType, "LineType", (printer)(PrintLineType) },
    { PEXOCLineWidth, "LineWidth", (printer)(PrintLineWidth) },
    { PEXOCLineColorIndex, "LineColorIndex", (printer)(PrintLineColorIndex) },
    { PEXOCLineColor, "LineColor", (printer)(PrintLineColor) },
    { PEXOCCurveApprox, "CurveApprox", (printer)(PrintCurveApprox) },
    { PEXOCPolylineInterpMethod, "PolylineInterpMethod", (printer)(PrintPolylineInterpMethod) },
    { PEXOCLineBundleIndex, "LineBundleIndex", (printer)(PrintLineBundleIndex) },
    { PEXOCInteriorStyle, "InteriorStyle", (printer)(PrintInteriorStyle) },
    { PEXOCInteriorStyleIndex, "InteriorStyleIndex", (printer)(PrintInteriorStyleIndex) },
    { PEXOCSurfaceColor, "SurfaceColor", PrintSurfaceColor },
    { PEXOCReflectionAttributes, "ReflectionAttributes", (printer)(PrintSurfaceColor) },
    { PEXOCReflectionModel, "ReflectionModel", (printer)(PrintReflectionModel) },
    { PEXOCSurfaceInterpMethod, "SurfaceInterpMethod", (printer)(PrintSurfaceInterpMethod) },
    { PEXOCBFInteriorStyle, "BFInteriorStyle", (printer)(PrintBFInteriorStyle) },
    { PEXOCBFInteriorStyleIndex, "BFInteriorStyleIndex", (printer)(PrintBFInteriorStyleIndex) },
    { PEXOCBFSurfaceColorIndex, "BFSurfaceColorIndex", (printer)(PrintBFSurfaceColorIndex) },
    { PEXOCBFSurfaceColor, "BFSurfaceColor", (printer)(PrintBFSurfaceColor) },
    { PEXOCBFReflectionAttributes, "BFReflectionAttributes", (printer)(PrintBFReflectionAttributes) },
    { PEXOCBFReflectionModel, "BFReflectionModel", (printer)(PrintBFReflectionModel) },
    { PEXOCBFSurfaceInterpMethod, "BFSurfaceInterpMethod", (printer)(PrintBFSurfaceInterpMethod) },
    { PEXOCSurfaceApprox, "SurfaceApprox", (printer)(PrintSurfaceApprox) },
    { PEXOCFacetCullingMode, "FacetCullingMode", (printer)(PrintFacetCullingMode) },
    { PEXOCFacetDistinguishFlag, "FacetDistinguishFlag", (printer)(PrintFacetDistinguishFlag) },
    { PEXOCPatternSize, "PatternSize", (printer)(PrintPatternSize) },
    { PEXOCPatternAttributes2D, "PatternAttributes2D", (printer)(PrintPatternAttributes2D) },
    { PEXOCPatternAttributes, "PatternAttributes", (printer)(PrintPatternAttributes) },
    { PEXOCInteriorBundleIndex, "InteriorBundleIndex", (printer)(PrintInteriorBundleIndex) },
    { PEXOCSurfaceEdgeFlag, "SurfaceEdgeFlag", (printer)(PrintSurfaceEdgeFlag) },
    { PEXOCSurfaceEdgeType, "SurfaceEdgeType", (printer)(PrintSurfaceEdgeType) },
    { PEXOCSurfaceEdgeWidth, "SurfaceEdgeWidth", (printer)(PrintSurfaceEdgeWidth) },
    { PEXOCSurfaceEdgeColorIndex, "SurfaceEdgeColorIndex", (printer)(PrintSurfaceEdgeColorIndex) },
    { PEXOCSurfaceEdgeColor, "SurfaceEdgeColor", (printer)(PrintSurfaceEdgeColor) },
    { PEXOCEdgeBundleIndex, "EdgeBundleIndex", (printer)(PrintEdgeBundleIndex) },
    { PEXOCIndividualASF, "IndividualASF", (printer)(PrintIndividualASF) },
    { PEXOCLocalTransform, "LocalTransform", (printer)(PrintLocalTransform) },
    { PEXOCLocalTransform2D, "LocalTransform2D", (printer)(PrintLocalTransform2D) },
    { PEXOCGlobalTransform, "GlobalTransform", (printer)(PrintGlobalTransform) },
    { PEXOCGlobalTransform2D, "GlobalTransform2D", (printer)(PrintGlobalTransform2D) },
    { PEXOCModelClipFlag, "ModelClipFlag", (printer)(PrintModelClipFlag) },
    { PEXOCModelClipVolume, "ModelClipVolume", (printer)(PrintModelClipVolume) },
    { PEXOCModelClipVolume2D, "ModelClipVolume2D", (printer)(PrintModelClipVolume2D) },
    { PEXOCRestoreModelClipVolume, "RestoreModelClipVolume", (printer)(NULL) },
    { PEXOCViewIndex, "ViewIndex", (printer)(PrintViewIndex) },
    { PEXOCLightSourceState, "LightSourceState", (printer)(PrintLightSourceState) },
    { PEXOCDepthCueIndex, "DepthCueIndex", (printer)(PrintDepthCueIndex) },
    { PEXOCPickID, "PickID", (printer)(PrintPickID) },
    { PEXOCHLHSRID, "HLHSRID", (printer)(PrintHLHSRID) },
    { PEXOCColorApproxIndex, "ColorApproxIndex", (printer)(PrintColorApproxIndex) },
    { PEXOCRenderingColorModel, "RenderingColorModel", (printer)(PrintRenderingColorModel) },
    { PEXOCParaSurfCharacteristics, "ParaSurfCharacteristics", (printer)(PrintParaSurfCharacteristics) },
    { PEXOCAddToNameSet, "AddToNameSet", (printer)(PrintAddToNameSet) },
    { PEXOCRemoveFromNameSet, "RemoveFromNameSet", (printer)(PrintRemoveFromNameSet) },
    { PEXOCLabel, "Label", PrintLabel },
    { PEXOCApplicationData, "ApplicationData", (printer)(PrintApplicationData) },
    { PEXOCGSE, "GSE", (printer)(PrintGSE) },
    { PEXOCMarkers, "Markers", (printer)(PrintMarkers) },
    { PEXOCMarkers2D, "Markers2D", (printer)(PrintMarkers2D) },
    { PEXOCText, "Text", (printer)(NULL) },
    { PEXOCText2D, "Text2D", (printer)(NULL) },
    { PEXOCAnnotationText, "AnnotationText", (printer)(NULL) },
    { PEXOCAnnotationText2D, "AnnotationText2D", (printer)(NULL) },
    { PEXOCPolyline, "Polyline", PrintPolyline },
    { PEXOCPolyline2D, "Polyline2D", PrintPolyline2D },
    { PEXOCPolylineSetWithData, "PolylineSetWithData", (printer)(PrintPolylineSetWithData) },
    { PEXOCNURBCurve, "NURBCurve", (printer)(PrintNURBCurve) },
    { PEXOCFillArea, "FillArea", (printer)(PrintFillArea) },
    { PEXOCFillArea2D, "FillArea2D", (printer)(PrintFillArea2D) },
    { PEXOCFillAreaWithData, "FillAreaWithData", (printer)(PrintFillAreaWithData) },
    { PEXOCFillAreaSet, "FillAreaSet", (printer)(PrintFillAreaSet) },
    { PEXOCFillAreaSet2D, "FillAreaSet2D", (printer)(PrintFillAreaSet2D) },
    { PEXOCFillAreaSetWithData, "FillAreaSetWithData", (printer)(PrintFillAreaSetWithData) },
    { PEXOCTriangleStrip, "TriangleStrip", PrintTriangleStrip },
    { PEXOCQuadrilateralMesh, "QuadrilateralMesh", (printer)(PrintQuadrilateralMesh) },
    { PEXOCSetOfFillAreaSets, "SetOfFillAreaSets", (printer)(PrintSetOfFillAreaSets) },
    { PEXOCNURBSurface, "NURBSurface", (printer)(PrintNURBSurface) },
    { PEXOCCellArray, "CellArray", (printer)(PrintCellArray) },
    { PEXOCCellArray2D, "CellArray2D", (printer)(PrintCellArray2D) },
    { PEXOCExtendedCellArray, "ExtendedCellArray", (printer)(PrintExtendedCellArray) },
    { PEXOCGDP, "GDP", (printer)(PrintGDP) },
    { PEXOCGDP2D, "GDP2D", (printer)(PrintGDP2D) },
    { PEXOCNoop, "Noop", (printer)(NULL) },
    { PEXOCNil, "Nil", (printer)(NULL) }
};

OpcodeData *FindOpcode (int oc_type)
{
    for (int i = 0; i < XtNumber (opcodes); i++)
	if (opcodes[i].oc_type == oc_type)
	    return opcodes + i;

    XnErrorMessage ("element type %d not yet supported.", oc_type);

    return NULL;
}

